/*
 *			M O N S T E R
 *
 *	Pour remplacer le champ de bubulles...
 *	nouveau 6 mai 2022, après un apéro Picto
 *
 */
/*    ======================================================    */

#declare SX_monst = 9.40;
#declare SY_monst =  2.45;
#declare SZ_monst = SX_monst;
#declare HB_monst =  0.33;		// hauteur base

/*    ======================================================    */
/*
 *	14 mai 2022 : on va essayer de charger un .PGM pour
 *	en faire un height_field...
 */

#declare HFDIR  = "frames/gravfield/";
#declare HFCK   = mod(clock, 2000);

#declare HFNAME = concat(HFDIR, str(HFCK , -5, 0), ".pgm");
#debug concat("    monster HF = ", HFNAME, "\n\n")

#declare HField_Monster = object
{
height_field {
        pgm	HFNAME
        smooth    			// on
        translate <-0.5, 0, -0.5>
	}
rotate 90*y
scale <SX_monst*1.88, 4.95, SZ_monst*1.88>
texture { Lightning2 scale <15, 43, 16> }
translate 0.26*y
}
/*    ======================================================    */
/*
 *	un petit piedestal pour elever le monstre
 *	nouveau 16 decembre 2022
 */

#local SX  = SX_monst + 1.19;
#local SZ  = SZ_monst + 1.18;

#local EchX = SX_monst + 0.06;		// was 0.18
#local EchZ = SZ_monst + 0.06;

/*    ------------------------------------------------------    */

#local Texture_Base_Monstre = texture
{
#local SC = 0.20 + 0.480*abs(cos((NormClock * 4.20)));

pigment { color (Gray70+(Red*0.67)) / 2.02 }
normal { bumps 0.65 scale SC }
finish { phong PHONG  specular SPECULAR }
}

/*    ------------------------------------------------------    */

#local H_cornes = SY_monst * 2.32;

#declare Les_Cornes_Du_Monstre = object
{
#local EX = SX - 0.51;
#local EZ = SZ - 0.51;
#local RA = 0.36;		/* rayon de la base des cornes */
#local RB = 0.165;		/* rayon des bulles d'en haut  */
#local RC = 0.067;		/* rayon du haut des cornes */
#local HA = H_cornes;
#local HB = HB_monst - 0.04;
#local HC = HA       + 1.71;	/* hauteur du point central */
#local HX = EchX - 0.26;
#local HZ = EchZ - 0.27;

merge	{ 
	cone   { < EX, HB, -EZ>, RA, < HX, HA, -HZ>, RC		}
	sphere {                   < HX, HA, -HZ>, RB		}
	cone   { < EX, HB,  EZ>, RA, < HX, HA,  HZ>, RC		}
	sphere {                   < HX, HA,  HZ>, RB		}
	cone   { <-EX, HB,  EZ>, RA, <-HX, HA,  HZ>, RC		}
	sphere {                   <-HX, HA,  HZ>, RB		}
	cone   { <-EX, HB, -EZ>, RA, <-HX, HA, -HZ>, RC		}
	sphere {                   <-HX, HA, -HZ>, RB		}

	/* la partie centrale */
	sphere   { 0, RB*1.18 scale <1, 2.2, 1> translate <0, HC+0.085, 0> } 
	cylinder { <-HX, HA, -HZ>, <0, HC, 0>, RC }
	cylinder { < HX, HA, -HZ>, <0, HC, 0>, RC }
	cylinder { <-HX, HA,  HZ>, <0, HC, 0>, RC }
	cylinder { < HX, HA,  HZ>, <0, HC, 0>, RC }
	}
texture {
	Texture_Base_Monstre
	translate y*(NormClock*13.925)
	}
}

/*    ------------------------------------------------------    */
/*    XXX
	il faut revoir l'alignement avec le haut des cornes */

#declare Le_Haut_De_La_Base = object
{
#local R   = 0.075;
union	{
	cylinder { <-HX, 0, -HZ>, < HX, 0, -HZ>, R }
	cylinder { <-HX, 0,  HZ>, < HX, 0,  HZ>, R }
	cylinder { < HX, 0, -HZ>, < HX, 0,  HZ>, R }
	cylinder { <-HX, 0, -HZ>, <-HX, 0,  HZ>, R }
	}
// texture { Texture_Base_Monstre }
texture { Nouvelle_Texture scale 3.33333 }
}
/*    ------------------------------------------------------    */

#declare Base_Du_Monstre_a = object
{
merge	{ 
	box  { <-SX, 0, -SZ>, <SX, HB_monst, SZ>		}
	box  { <-SX_monst, 0, -SZ_monst>,
				<SX_monst, HB_monst+0.03, SZ_monst> }
	}
texture {
	Texture_Base_Monstre
	rotate <0, 16+(17*NormClock), 0>
	}
}

#declare Base_Du_Monstre = object
{
union	{
	object { Le_Haut_De_La_Base translate y*H_cornes}
	object { Les_Cornes_Du_Monstre }
	object { Base_Du_Monstre_a }
	}
}
/*    ======================================================    */
/*
 *	un genre de machin pour accompagner (ou surveiller ?)
 *	le monstre.
 *	nouveau 19 decmbre 2022
 */

#local base_du_machin = object
{
merge	{
	/* la base */
	cylinder { <0, 0, 0>, <0, 0.15, 0>, 0.77777 }
	sphere { 0, 0.7777 scale <1, 0.17, 1> translate y*0.15 }
	}
texture { MON_VERT_INDUS }
}

#local pilier_du_machin = object
{
merge	{
	cylinder { <0, 0, 0>, <0, SY_monst*2.78, 0>, 0.19 }
	sphere   { <0, SY_monst*2.78, 0>, 0.19 }
	#local H2 = 5.50;
	cylinder { <0, H2, -0.30>, <0, H2, 0.30>, 0.40 }
	}
texture {
	pigment {
		gradient y
#include "volcanomap.incc"
		turbulence 0.23	
		scale 0.60
		translate y*(NormClock*2.718)
		}
	} // fin texture
}
#declare Machin_Du_Monstre = object
{
union	{
	object { base_du_machin }
	object { pilier_du_machin }
	}
}
/*    ======================================================    */
/*
 *	une sorte de cage pour enfermer le monstre
 */
#local FM_plaque = object
{
#local Xb = SX_monst - 0.14;
#local Zb = SZ_monst - 0.14;
difference {
	box { <-SX_monst,  0, -SZ_monst>, <SX_monst, 0.042,  SZ_monst> }
	box { <-Xb,       -1, -Zb>,       <Xb,       1,     Zb>       }
	}
}

/* le dessus de la cage */
#declare FM_top = object
{
union	{
	object { FM_plaque translate -y*0.04 }
	object { FM_plaque translate  y*0.04 }
	}
texture { GRIS_BROTCH }

}
#declare Cage_Monster = object
{
union	{
	#for (foo, 0.05, SY_monst+0.60, 0.240)
	#local bar = foo / SY_monst;
	  object { FM_plaque
			// scaling here ?
			pigment { color <bar, 0.65, 1-bar> }
			translate y*(foo*(0.14+NormClock)) }
	#end
	}
}

/*    ------------------------------------------------------    */
#declare Fake_Monster = object
{
union	{
	object { Base_Du_Monstre }
	object { Machin_Du_Monstre rotate -15*y
			translate <SX_monst+2.35, 0, 1.42> }

	#local H2 = HB_monst + 0.09;
	object { HField_Monster translate y*H2 }
	object { Cage_Monster   translate y*H2 }

	object { QuadriLampe rotate -y*clock translate <1.2, 9.80, -0.40> }
	}
}

/*    ======================================================    */
